unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

//------------------------------------------------------------------------
// Other types
//------------------------------------------------------------------------

type
  // Line status ( Clear To Send, Data Set Ready, Ring, Carrier Detect )
  TLineStatus = ( lsCTS, lsDSR, lsRING, lsCD );
  // Set of line status
  TLineStatusSet = set of TLineStatus;

var
    hPort: THandle;
    DCB:TDCB;
    count:byte;
    CommTimeOuts: TCOMMTIMEOUTS ;
///////////////////////////////////////////////////////////////////////////
type
  TForm1 = class(TForm)
    Panel2: TPanel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    Image1: TImage;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    Timer1: TTimer;
    Panel1: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Timer2: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Panel4Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  myPoint:TPoint;
  down:boolean;
implementation

{$R *.dfm}
//Open Port
procedure OpenCOM(i:integer);

begin

  hPort := CreateFile(PChar('COM'+inttostr(i)), GENERIC_READ or GENERIC_WRITE, 0, nil,
  OPEN_EXISTING, FILE_FLAG_OVERLAPPED, 0);

  if (hPort=INVALID_HANDLE_VALUE) then
  begin
    ShowMessage('Can not open port COM'+inttostr(i));
    exit;
  end;

  GetCommState(hPort,DCB);
  DCB.BaudRate:=CBR_1200;
  DCB.ByteSize:=8;
  DCB.Parity:=NOPARITY;
  DCB.StopBits:=ONESTOPBIT;
  DCB.Flags:=(DCB.Flags And $FFFFC0FF) Or $00000100;

  SetCommState(hPort,DCB);

  CommTimeOuts.ReadIntervalTimeout:= 5;
  CommTimeOuts.ReadTotalTimeoutMultiplier := 1;
  CommTimeOuts.ReadTotalTimeoutConstant := 5;
  //
  CommTimeOuts.WriteTotalTimeoutMultiplier := 10;
  CommTimeOuts.WriteTotalTimeoutConstant := 10;
  SetCommTimeouts(hPort,CommTimeOuts);
end;
// Returns CTS, DSR, RING and RLSD (CD) signals status 
function GetLineStatus: TLineStatusSet;
var dwS: DWORD;
begin
  Result := [];
  // Retrieves modem control-register values.
  // The function fails if the hardware does not support the control-register
  // values. 
  if not GetCommModemStatus( hPort, dwS ) then
    exit;
  if dwS and MS_CTS_ON <> 0 then Result := Result + [lsCTS];
  if dwS and MS_DSR_ON <> 0 then Result := Result + [lsDSR];
  if dwS and MS_RING_ON <> 0 then Result := Result + [lsRING];
  if dwS and MS_RLSD_ON <> 0 then Result := Result + [lsCD];
end;

procedure SetTo0;
var
  i:integer;
begin
  if(lsCD in GetLineStatus=false)then
  for i:=0 to 300 do
  begin
      EscapeCommFunction(hPort,CLRRTS);
      EscapeCommFunction(hPort,SETRTS);
    if(lsCD in GetLineStatus=true)then break;
  end;

  for i:=0 to 300 do
  begin
      EscapeCommFunction(hPort,CLRRTS);
      EscapeCommFunction(hPort,SETRTS);
    if(lsCD in GetLineStatus=false)then break;
  end;
  count:=0;
end;

procedure setInt(x:integer);
var
  i:integer;
begin
  if x<>count then
  if x<=16 then
  begin
    SetTo0;
    for i:=1 to x do
    begin
      EscapeCommFunction(hPort,CLRRTS);
      EscapeCommFunction(hPort,CLRRTS);
      EscapeCommFunction(hPort,SETRTS);
      EscapeCommFunction(hPort,SETRTS);
    end;
    count:=x;
  end;
end;
function getCount: integer;
begin
  result:=count;
end;
////////////////////////////////////////////////////////////////////////////////
procedure TForm1.FormCreate(Sender: TObject);
var
  cmd : string;
  i : Integer;
begin


  if ParamCount>0 then
  begin
  if (ParamStr(1)='/?') then
      begin
      showmessage(' : /s <  0-15>');
      showmessage(' c: /-s');
      end;

      if (ParamStr(1)='/-s') then  setTo0;

      if ParamCount>1 then
      begin
        if (ParamStr(1)='/s') then  setInt(strtoint(ParamStr(2)));
      end;
      Application.Terminate;
  end;

  OpenCOM(1);
  SetTo0;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  SetTo0;
  CloseHandle(hPort);
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
      if key=VK_UP    then setInt(1);
      if key=VK_DOWN  then setInt(2);
      if key=VK_LEFT  then setInt(4);
      if key=VK_RIGHT then setInt(8);

      RadioButton1.Checked:=(key=VK_UP   );
      RadioButton2.Checked:=(key=VK_DOWN );
      RadioButton3.Checked:=(key=VK_LEFT );
      RadioButton4.Checked:=(key=VK_RIGHT);
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
       setTo0;

      RadioButton1.Checked:=false;
      RadioButton2.Checked:=false;
      RadioButton3.Checked:=false;
      RadioButton4.Checked:=false;
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    //  showmessage('');
     myPoint.X:=X;
     myPoint.Y:=Y;
     down:=true;
     Timer1.Enabled:=down;
end;

procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    down:=false;
    Timer1.Enabled:=false;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
Form1.CloseQuery;
application.Terminate;

end;

procedure TForm1.Timer1Timer(Sender: TObject);
  var Point:TPoint;
begin
  getCursorPos(Point);
  left:=Point.X-myPoint.X;
  top :=Point.Y-myPoint.Y+20;
end;

procedure TForm1.Panel4Click(Sender: TObject);
begin
Timer2.Enabled:=not Timer2.Enabled;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
    EscapeCommFunction(hPort,CLRRTS);
    EscapeCommFunction(hPort,CLRRTS);
    EscapeCommFunction(hPort,SETRTS);
    EscapeCommFunction(hPort,SETRTS);
end;

end.
